package body test_queues is
    
    function is_empty ( Q : queue ) return boolean is
    begin
        return Q.size = 0;
    end function is_empty;
    
    function is_full ( Q : queue ) return boolean is
    begin
        return Q.size = max_size;
    end function is_full;
    
    procedure add ( Q : inout queue;  item : in test ) is
    begin
        if not is_full(Q) then
            Q.the_buffer(Q.tail) := item;
            Q.tail := (Q.tail + 1) mod max_size;
            Q.size := Q.size + 1;
        end if;
    end procedure add;
    
    procedure remove ( Q : inout queue;  item : out test ) is
    begin
        if not is_empty(Q) then
            item := Q.the_buffer(Q.head);
            Q.head := (Q.head + 1) mod max_size;
            Q.size := Q.size - 1;
        end if;
    end procedure remove;
    
end package body test_queues;
