package body queues is
    
--    impure function new_queue return queue is
--    begin
--        return queue'(null, null);
--    end function new_queue;

    
    procedure make_queue ( Q : out queue ) is
    begin
        Q := queue'(null, null);
    end procedure make_queue;

    
    impure function is_empty ( Q : queue ) return boolean is
    begin
        return Q.head = null;
    end function is_empty;
    
    
    procedure append ( Q : inout queue;  E : in element_type ) is
        variable new_element : element_ptr := new element_node'(
            value => E,
            next_element => null,
            prev_element => Q.tail );
    begin
        if Q.head = null then
            Q.head := new_element;
        end if;
        Q.tail := new_element;
    end procedure append;

    
    procedure extract_head ( Q : inout queue;  E : out element_type ) is
        variable head_element : element_ptr;
    begin
        if not is_empty(Q) then
            head_element := Q.head;
            E := head_element.value;
            Q.head := head_element.next_element;
            if Q.head = null then
                Q.tail := null;
            end if;
            deallocate ( head_element );
        end if;
    end procedure extract_head;
    
end package body queues;
