use work.instructions.all;
use work.indexed_addressing_mixin;

package load_instructions is

    type load_instruction is
	abstract new instruction with record
            destination : register_number;
        end record load_instruction;


    package indexed_loads is new indexed_addressing_mixin
        generic map ( parent_instruction => load_instruction );
                             
    alias indexed_load_instruction is indexed_loads.indexed_instruction;

end package load_instructions;
